{
var
SpFileStream: TSpFileStream;
SpVoice: TSpVoice;
Voices:ISpeechObjectTokens;
i:integer;
begin
SpFileStream := TSpFilestream.Create(nil);
SpVoice := TSpVoice.Create(nil);
try
SpFileStream.Format.type_ := SAFT11kHz8BitMono;
SpFileStream.Open('test.wav', SSFMCreateForWrite, FALSE);
SpVoice.AudioOutputStream := SPFileStream.DefaultInterface;
Voices:=SpVoice.GetVoices('', '');
for i := 0 to Voices.Count - 1 do
if Pos('Alyona', Voices.Item(i).GetAttribute('Name')) = 1 then
begin
SpVoice.Voice := Voices.Item(i);
Break;
end;
SpVoice.SynchronousSpeakTimeout := 1000;
SpVoice.Speak('!', SVSFlagsAsync);
SpVoice.WaitUntilDone(3000);
finally
SpVoice.Free;;
SpFileStream.Free;
end;
end;
...
}



unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleServer, SpeechLib_TLB, StdCtrls, Comobj, ExtCtrls;

const
  gset: array [0..10] of string =('','','','','','','','','','','');
  sset: array [0..21] of string =('','','','','','','','','','','','','','','','','','','','','','');
  qset: array [0..7] of LongWord = (SAFT16kHz16BitMono, SAFT16kHz8BitMono, SAFT12kHz16BitMono, SAFT12kHz8BitMono, SAFT11kHz16BitMono, SAFT11kHz8BitMono, SAFT8kHz16BitMono, SAFT8kHz8BitMono);

type
  TForm1 = class(TForm)
    Button1: TButton;
    SpVoiceRu: TSpVoice;
    cbVoicesRu: TComboBox;
    EditTextRus: TEdit;
    EditTextEng: TEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button3: TButton;
    Label1: TLabel;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Label4: TLabel;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    ComboBox2: TComboBox;
    Label5: TLabel;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbVoicesRuChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;
  stop:boolean;
  SOTokensRu,SOTokensEng: ISpeechObjectTokens;
  SOTokenRu, SOTokenEng: ISpeechObjectToken;
  SpFileStream: TSpFileStream;
  vsren, packet:TStringList;
  AppPath,file_vs:string;
  numLines:integer;
  stl:string;
  CountFile:integer;
  
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
//var
 //  voice: OLEVariant;
 //  hr:HRESULT;
begin
 //SpVoice1.Speak('Hello world!', SVSFDefault);
//  voice := CreateOLEObject('SAPI.SpVoice');
//   voice.Speak('WTF!', 0);

// SpFileStream := TSpFilestream.Create(nil);
// SpFileStream.Format.type_ := SAFT12kHz16BitMono;
 SpFileStream.Open('test'+inttostr(countfile)+'.wav', SSFMCreateForWrite, FALSE);
{ if RadioButton2.Checked then} SpVoiceRu.AudioOutputStream := SPFileStream.DefaultInterface;
//  else
//  begin
// ?????????????????????????????
//  end;
 Button5Click(self);
// inc(countfile);

//  if CheckBox1.Checked then EditTextRus.Text:='' else stl:=EditTextRus.Text;
//  if EditTextRus.Visible then EditTextRus.Text:=stl;
//  if stl = '' then exit;
//  SpVoiceRu.SynchronousSpeakTimeout := 1000;

{  stop:=false;
    if cbVoicesRu.ItemIndex=0 then //Angl
     begin
      SpVoiceRu.Rate:=-4;
      SpVoiceRu.Volume:=100;
   //   hr:=SpVoiceRu.Speak(EditTextEng.Text, SVSFDefault);
     end;

    if cbVoicesRu.ItemIndex=1 then //
     begin
      SpVoiceRu.Rate:=-2;
      SpVoiceRu.Volume:=100;
   //   hr:=SpVoiceRu.Speak(stl, SVSFDefault);
     end;
     
    if cbVoicesRu.ItemIndex=2 then //
     begin
      SpVoiceRu.Rate:=8;
      SpVoiceRu.Volume:=100;
     // hr:=SpVoiceRu.Speak(stl, SVSFDefault);
     end;          }

 // SpVoiceRu.WaitUntilDone(3000);
  SpFileStream.Close;
//  SpFileStream.free;
end;

procedure TForm1.FormCreate(Sender: TObject);
 var I: Integer;
begin
// SpVoiceRu.Create(nil);
 SpVoiceRu.EventInterests := SVEAllEvents;
 SOTokensRu := SpVoiceRu.GetVoices('', '');
 for I := 0 to SOTokensRu.Count - 1 do begin
  //For each voice, store the descriptor in the TStrings list
  SOTokenRu := SOTokensRu.Item(I);
  cbVoicesRu.Items.AddObject(SOTokenRu.GetDescription(0), TObject(SOTokenRu));
  //Increment descriptor reference count to ensure it's not destroyed
  SOTokenRu._AddRef;
 end;
 cbVoicesRu.ItemIndex:=1;
 SOTokenRu := ISpeechObjectToken(Pointer(cbVoicesRu.Items.Objects[cbVoicesRu.ItemIndex]));
 SpVoiceRu.Voice := SOTokenRu;
 
 packet := TStringList.Create;
 vsren := TStringList.Create;
 stl:=EditTextRus.Text;
 SpFileStream := TSpFilestream.Create(nil);
 ComboBox1Change(self);
 ComboBox2Change(self);
 Button3Click(self);
end;

procedure TForm1.cbVoicesRuChange(Sender: TObject);
 var SOTokenRu: ISpeechObjectToken;
begin
 SOTokenRu := ISpeechObjectToken(Pointer(cbVoicesRu.Items.Objects[cbVoicesRu.ItemIndex]));
 SpVoiceRu.Voice := SOTokenRu;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 vsren.Free;
 packet.Free;
 SpFileStream.free;
 SpVoiceRu.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 AppPath := AnsiUpperCase(ExtractFilePath(ParamStr(0)));
// file_vs:=AppPath+'Words\1490789.txt';
 file_vs:=AppPath+'slogi.txt';
// vs.Delimiter:=' ';
 vsren.LoadFromFile(file_vs);
 numLines:=vsren.Count;
 label1.Caption:=inttostr(numLines);
 Randomize;
end;

procedure TForm1.Button4Click(Sender: TObject);
 var n,i,len:integer;
begin
 Randomize;
 label2.Caption:='';
 application.ProcessMessages;
 stl:='';
 len:=strtoint(edit1.Text);

 vsren.Clear;
 numLines:=50;
 for i:=1 to numLines do begin
  n:=random(2);
  if n=1 then vsren.Add(sset[random(21)]+gset[random(10)]) else vsren.Add(gset[random(10)]+sset[random(21)]);
 end;

 for i:=1 to len do begin
  n:=Random(numLines);
  stl:=stl+vsren.Strings[n];
 end;

// SpVoiceRu.Rate:=-4; // () 
 SpVoiceRu.Volume:=100;

 Button5Click(self);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 SpVoiceRu.Speak(edittextrus.Text, SVSFDefault);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 SpVoiceRu.Speak(stl, SVSFDefault);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 label2.Caption:=stl;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
 SpFileStream.Format.type_:=qset[ComboBox1.ItemIndex];
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
 SpVoiceRu.Rate:=strtoint(ComboBox2.text);
end;

procedure TForm1.Button2Click(Sender: TObject);
 var i,n:integer;
begin
 if OpenDialog1.Execute then begin
  Button2.Enabled:=false;
  packet.LoadFromFile(OpenDialog1.FileName);
  n:=packet.Count;
  if n>0 then begin
   for i:=0 to (n-1) do begin
    SpFileStream.Open(packet.Strings[i]+'.wav', SSFMCreateForWrite, FALSE);
    SpVoiceRu.AudioOutputStream := SPFileStream.DefaultInterface;
    SpVoiceRu.Speak(packet.Strings[i], SVSFDefault);
    SpFileStream.Close;
   end;
  end;
  Button2.Enabled:=true;
 end;
end;

end.
